<template>
  <q-card
    :square="!isDesktopPlatform"
    class="column no-wrap col"
  >
    <q-banner class="bg-grey-3 text-grey-8 q-mb-md">
      <translate>This recommendation for nitrogen fertilisation is provided by REQUAFERTI, a web tool developed by the ASBL REQUASUD and based on the method of the projected nitrogen balance at the plot level.</translate>
    </q-banner>

    <FertilizationResultHeader
      :plot-id="plotId"
      :plot-name="plotName"
      :plant-species-name="plantSpeciesName"
      :crop-yield="cropYield"
      :crop-yield-unit="cropYieldUnit"
    />

    <div class="q-pb-sm">
      <RequafertiResultItem
        :npk-element="needsNElement"
        :label="$gettext('Needs')"
      />

      <RequafertiResultItem
        :npk-element="suppliesNElement"
        :label="$gettext('Supplies')"
      />

      <RequafertiResultItem
        :npk-element="recommendationNElement"
        :label="$gettext('Recommendation')"
        bold
      />

      <div class="text-caption text-grey text-left q-ml-md">
        <translate>All numbers in kg/ha</translate>
      </div>

      <q-banner
        v-if="displayRecommendationNegativeWarning"
        class="bg-grey-3 text-grey-8 q-mx-md q-mt-sm"
      >
        <q-icon
          name="las la-exclamation-circle"
          class="q-pr-xs"
        />
        <translate>The recommendation is negative: there is too much nitrogen provided to the crop.</translate>
      </q-banner>
    </div>

    <!-- buttons -->
    <slot name="action-buttons" />
  </q-card>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import RequafertiResultItem from 'src/pages/fieldbook/fertilization/algorithms/requaferti/components/RequafertiResultItem'
import FertilizationResultHeader from 'src/pages/fieldbook/fertilization/algorithms/common/components/FertilizationResultHeader'
import { resultTypes } from 'src/services/fieldbook/fertilization/fertilizationPlan'

export default {
  name: 'RequafertiResultsCard',
  mixins: [PlatformMixin],
  components: {
    RequafertiResultItem,
    FertilizationResultHeader
  },
  props: {
    fertilizationPlanResults: {
      type: Object,
      required: true
    }
  },
  computed: {
    plotId () {
      return this.fertilizationPlanResults.plot_id
    },
    plotName () {
      return String(this.fertilizationPlanResults.plot_name || this.fertilizationPlanResults.plot_id)
    },
    plantSpeciesName () {
      return this.fertilizationPlanResults.plant_species_name
    },
    cropYield () {
      return this.fertilizationPlanResults.crop_yield
    },
    cropYieldUnit () {
      return this.fertilizationPlanResults.crop_yield_unit
    },
    needsNElement () {
      return this.fertilizationPlanResults.element_recommendations.find(element => element.result_type === resultTypes.PLANT_NEEDS)
    },
    suppliesNElement () {
      return this.fertilizationPlanResults.element_recommendations.find(element => element.result_type === resultTypes.PLANT_SUPPLIES)
    },
    recommendationNElement () {
      return this.fertilizationPlanResults.element_recommendations.find(element => element.result_type === resultTypes.RECOMMENDATION)
    },
    displayRecommendationNegativeWarning () {
      return this.recommendationNElement?.quantity < 0
    }
  }
}
</script>
